unit UnitNt2000Hook;

interface

uses classes, Windows,SysUtils, messages,dialogs;

type
  TAllocCSToDSAlias = function(CSSeg: DWORD): DWORD;
  TImportCode = packed record
     JumpInstruction: Word;
     AddressOfPointerToFunction: PPointer;
  end;
  PImage_Import_Entry = ^Image_Import_Entry;
  Image_Import_Entry = record
    Characteristics: DWORD;
    TimeDateStamp: DWORD;
    MajorVersion: Word;
    MinorVersion: Word;
    Name: DWORD;
    LookupTable: DWORD;
  end;
  PImportCode = ^TImportCode;
  TLongJmp = packed record
     JmpCode: ShortInt; {ָ$E9ϵͳָ}
     FuncAddr: DWORD; {ַ}
  end;

  THookClass = class
  private
     Trap:boolean; {÷ʽTrueʽFalseʽ}
     hProcess: Cardinal; {ֻ̾ʽ}
     AlreadyHook:boolean; {ǷѰװHookֻʽ}
     AllowChange:boolean; {ǷװжHookֻڸʽ}
     Oldcode: array[0..4]of byte; {ϵͳԭǰ5ֽ}
     Newcode: TLongJmp; {Ҫдϵͳǰ5ֽ}
  private
  public
     OldFunction,NewFunction:Pointer;{غԶ庯}
     constructor Create(IsTrap:boolean;OldFun,NewFun:pointer);
     constructor Destroy;
     procedure Restore;
     procedure Change;
  published
  end;

implementation

function FP_Off(APtr: Pointer): WORD;
begin
  Result := WORD(DWORD(APtr));
end;

function FP_Seg(APtr: Pointer): WORD;
begin
  Result := WORD((DWORD(APtr) shr 16));
end;

function MK_FP(ASeg: WORD; AOff: WORD): Pointer;
begin
  Result := Pointer((DWORD(ASeg) shl 16) + DWORD(AOff));
end;

function WriteCSMemory(Target: Pointer; DataBuff: Pointer;
  DataLen: Integer): Boolean;
var
  DSSelector: DWORD;
  OffSet: WORD;
  NewPtr: Pointer;
  hKernel: HMODULE;
  AllocCSToDSAlias: TAllocCSToDSAlias;
begin
  Result := True;
  OffSet := FP_Off(Target);
  try
    hKernel := GetModuleHandle('Kernel');
    AllocCsToDsAlias := TAllocCSToDSAlias(
      GetProcAddress(hKernel,'AllocCsToDsAlias'));
    DsSelector := AllocCsToDsAlias(FP_Seg(Target));
    NewPtr := MK_FP(DsSelector,OffSet);
    CopyMemory(NewPtr,DataBuff,DataLen);
  except
    Result:=False;
  end;
end;

{ȡʵʵַĵһָJmpȡתַʵʵַڳкDebugϢ}
function FinalFunctionAddress(Code: Pointer): Pointer;
Var
  func: PImportCode;
begin
  Result:=Code;
  if Code=nil then exit;
  try
    func:=code;
    if (func.JumpInstruction=$25FF) then
      {ָFF 25  ָjmp [...]}
      Func:=func.AddressOfPointerToFunction^;
    result:=Func;
  except
    Result:=nil;
  end;
end;

{ָĵַֻڸʽ}
function PatchAddressInModule(BeenDone:Tlist;hModule: THandle; OldFunc,NewFunc: Pointer):integer;
const
   SIZE=4;
Var
   Dos: PImageDosHeader;
   NT: PImageNTHeaders;
   ImportDesc: PImage_Import_Entry;
   rva: DWORD;
   Func: PPointer;
   DLL: String;
   f: Pointer;
   written: DWORD;
   mbi_thunk:TMemoryBasicInformation;
   dwOldProtect:DWORD;
begin
  Result:=0;
  if hModule=0 then exit;
  Dos:=Pointer(hModule);
  {DLLģѾ˳BeenDoneѴDLLģ}
  if BeenDone.IndexOf(Dos)>=0 then exit;
  BeenDone.Add(Dos);{DLLģBeenDone}
  OldFunc:=FinalFunctionAddress(OldFunc);{ȡʵʵַ}

  {DLLģĵַܷʣ˳}
  if IsBadReadPtr(Dos,SizeOf(TImageDosHeader)) then exit;
  {ģ鲻'MZ'ͷDLL˳}
  if Dos.e_magic<>IMAGE_DOS_SIGNATURE then exit;{IMAGE_DOS_SIGNATURE='MZ'}

  {λNT Header}
  NT :=Pointer(Integer(Dos) + dos._lfanew);
  {λ뺯}
  RVA:=NT^.OptionalHeader.
     DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress;
  if RVA=0 then exit;{뺯Ϊգ˳}
  {ѺԵַRVAתΪԵַ}
  ImportDesc := pointer(DWORD(Dos)+RVA);{DosǴDLLģ׵ַ}

  {б¼DLLģ}
  While (ImportDesc^.Name<>0) do
  begin
    {¼DLLģ}
    DLL:=PChar(DWORD(Dos)+ImportDesc^.Name);
    {ѱ¼DLLģ鵱ǰģ飬еݹ}
    PatchAddressInModule(BeenDone,GetModuleHandle(PChar(DLL)),OldFunc,NewFunc);

    {λ¼DLLģĺ}
    Func:=Pointer(DWORD(DOS)+ImportDesc.LookupTable);
    {¼DLLģк}
    While Func^<>nil do
    begin
      f:=FinalFunctionAddress(Func^);{ȡʵʵַ}
      if f=OldFunc then {ʵʵַҪҵĵַ}
{$IFDEF CS_DS}
        WriteCSMemory(Func,@NewFunc,SIZE);
{$ENDIF}
{$IFNDEF CS_DS}
      begin
        ZeroMemory(@mbi_thunk,SizeOf(TMemoryBasicInformation));
        VirtualQuery(Func,mbi_thunk, sizeof(TMemoryBasicInformation));
        dwOldProtect := mbi_thunk.Protect;
        VirtualProtect(Func,SIZE,PAGE_EXECUTE_WRITECOPY,mbi_thunk.Protect);{ڴ}
        WriteProcessMemory(GetCurrentProcess,Func,@NewFunc,SIZE,written);{ºַ}
        VirtualProtect(Func, SIZE, mbi_thunk.Protect,dwOldProtect);{ָڴ}
      end;
{$ENDIF}
      If Written=4 then Inc(Result);
//      else showmessagefmt('error:%d',[Written]);
      Inc(Func);{һܺ}
    end;
    Inc(ImportDesc);{һ¼DLLģ}
  end;
end;

{HOOKڣIsTrapʾǷʽ}
constructor THookClass.Create(IsTrap:boolean;OldFun,NewFun:pointer);
begin
   {󱻽غԶ庯ʵʵַ}
   OldFunction:=FinalFunctionAddress(OldFun);
   NewFunction:=FinalFunctionAddress(NewFun);

   Trap:=IsTrap;
   if Trap then{ʽ}
   begin
      {Ȩķʽ򿪵ǰ}
      hProcess := OpenProcess(PROCESS_ALL_ACCESS,FALSE, GetCurrentProcessID);
      {jmp xxxxĴ룬5ֽ}
      Newcode.JmpCode := ShortInt($E9); {jmpָʮƴE9}
      NewCode.FuncAddr := DWORD(NewFunction) - DWORD(OldFunction) - 5;
      {汻غǰ5ֽ}
      move(OldFunction^,OldCode,5);
      {ΪûпʼHOOK}
      AlreadyHook:=false;
   end;
   {ǸʽHOOK}
   if not Trap then AllowChange:=true;
   Change; {ʼHOOK}
   {ǸʽʱHOOK}
   if not Trap then AllowChange:=false;
end;

{HOOKĳ}
constructor THookClass.Destroy;
begin
   {ǸʽHOOK}
   if not Trap then AllowChange:=true;
   Restore; {ֹͣHOOK}
   if Trap then{ʽ}
      CloseHandle(hProcess);
end;

{ʼHOOK}
procedure THookClass.Change;
var
   nCount: DWORD;
   BeenDone: TList;
   mbi_thunk: TMemoryBasicInformation;
   dwOldProtect: DWORD;
begin
  if Trap then{ʽ}
  begin
    if (AlreadyHook)or (hProcess = 0) or (OldFunction = nil) or (NewFunction = nil) then
        exit;
    AlreadyHook:=true;{ʾѾHOOK}
{$IFDEF CS_DS}
    WriteCSMemory(OldFunction,@(NewCode),5);
{$ENDIF}
{$IFNDEF CS_DS}
    ZeroMemory(@mbi_thunk, SizeOf(TMemoryBasicInformation));
    VirtualQueryEx(hProcess,OldFunction,mbi_thunk, sizeof(TMemoryBasicInformation));
    dwOldProtect := mbi_thunk.Protect;
    VirtualProtectEx(hProcess,OldFunction,5,PAGE_EXECUTE_WRITECOPY,mbi_thunk.Protect);{ڴ}
    WriteProcessMemory(hProcess,OldFunction,@(Newcode),5,nCount);{ºַ}
    VirtualProtectEx(hProcess,OldFunction, 5, mbi_thunk.Protect,dwOldProtect);{ָڴ}
{$ENDIF}
  end
  else begin{Ǹʽ}
       if (not AllowChange)or(OldFunction=nil)or(NewFunction=nil)then exit;
       BeenDone:=TList.Create; {ڴŵǰDLLģ}
       try
         PatchAddressInModule(BeenDone,GetModuleHandle(nil),OldFunction,NewFunction);
       finally
         BeenDone.Free;
       end;
  end;
end;

{ָϵͳĵ}
procedure THookClass.Restore;
var
   nCount: DWORD;
   BeenDone: TList;
begin
  if Trap then{ʽ}
  begin
    if (not AlreadyHook) or (hProcess = 0) or (OldFunction = nil) or (NewFunction = nil) then
        exit;
    WriteProcessMemory(hProcess, OldFunction, @(Oldcode), 5, nCount);
    AlreadyHook:=false;{ʾ˳HOOK}
  end
  else begin{Ǹʽ}
    if (not AllowChange)or(OldFunction=nil)or(NewFunction=nil)then exit;
    BeenDone:=TList.Create;{ڴŵǰDLLģ}
    try
      PatchAddressInModule(BeenDone,GetModuleHandle(nil),NewFunction,OldFunction);
    finally
      BeenDone.Free;
    end;
  end;
end;

end.

